/**********************************************************************/
/*                                                                    */
/* gui.h:   LISPME user interface functions                           */
/*                                                                    */
/* LispMe System (c) FBI Fred Bayer Informatics                       */
/*                                                                    */
/* Distributed under the GNU General Public License;                  */
/* see the README file. This code comes with NO WARRANTY.             */
/*                                                                    */
/* Modification history                                               */
/*                                                                    */
/* When?      What?                                              Who? */
/* -------------------------------------------------------------------*/
/* 10.01.1999 New                                                FBI  */
/* 25.10.1999 Prepared for GPL release                           FBI  */
/* 01.04.2000 Prepared for GCC 2.0 and SDK 3.5                   FBI  */
/*                                                                    */
/**********************************************************************/

#ifndef INC_GUI_H
#define INC_GUI_H

/**********************************************************************/
/* Includes                                                           */
/**********************************************************************/
#include "builtin.h"

/**********************************************************************/
/* Structures                                                         */
/**********************************************************************/
struct UIContext {
  PTR prevCont; // continuation in previous event handler for frm-return
  PTR handler;  // current event handler procedure
  PTR data;     // data whose extent is the same as the form
  int timeout;  // timeout in ticks
};

#define MAX_GUI_NEST 6

/**********************************************************************/
/* Exported variables                                                 */
/**********************************************************************/
extern Boolean          returning;
extern Boolean          newTimeDlg;
extern struct UIContext contexts[];
extern int              actContext;

extern BuiltInModule eventBuiltins;
extern BuiltInModule guiBuiltins; 
extern BuiltInModule guiBuiltins2; 

/**********************************************************************/
/* prototypes                                                         */
/**********************************************************************/
Boolean LispHandleEvent(EventType *e);
void    DoLMEvent(EventType *e);
void    popupForm(UInt16 resId, int timeout, PTR handler);
void    gotoForm(UInt16 resId, int timeout, PTR handler);

#endif
